module ABNF
  module Parser
    class Compiler
      class Alternation < RuleBuilder
        def alternation_slash _
        end

        def alternative rule
          alternatives << rule
        end

        def alternatives
          @alternatives ||= []
        end

        def c_nl token
          finished
          compiler.handle token
        end

        def c_wsp _
        end

        def group_stop token
          finished
          compiler.handle token
        end

        def finished
          if alternatives.size == 1
            rule = alternatives[0]
          else
            abnf = alternatives.map &:abnf
            abnf *= ' / '
            rule = Rules::Alternation.new alternatives, abnf
          end

          compiler.pop rule
        end

        def option_stop token
          finished
          compiler.handle token
        end

        def start_rule token
          compiler.push Concatenation do |rule|
            alternative rule
          end
        end
      end
    end
  end
end
