module ABNF
  module Parser
    class Compiler
      class Concatenation < RuleBuilder
        def alternation_slash _
          finished
        end

        def c_nl token
          finished
          compiler.handle token
        end

        def c_wsp _
        end

        def group_stop token
          finished
          compiler.handle token
        end

        def finished
          if repetitions.size == 1
            rule = repetitions.first
          else
            abnf = repetitions.map &:abnf
            abnf *= ' '
            rule = Rules::Concatenation.new repetitions, abnf
          end

          compiler.pop rule
        end

        def option_stop token
          finished
          compiler.handle token
        end

        def repetition repetition
          repetitions << repetition
        end

        def repetitions
          @repetitions ||= []
        end

        def start_rule token
          compiler.push Repetition do |element|
            repetition element
          end
        end
      end
    end
  end
end
