module ABNF
  module Parser
    class Compiler
      class Repetition < RuleBuilder
        attr_writer :abnf
        attr_accessor :element
        attr_accessor :range

        def abnf
          @abnf ||= ''
        end

        def finished element
          abnf << element.abnf

          if range
            rule = Rules::Repetition.new element, range, abnf
          else
            rule = element
          end

          compiler.pop rule
        end

        def repeat_exact token
          number = token.lexeme.to_i

          self.abnf = token.abnf
          self.range = (number..number)
        end

        def repeat_range token
          minimum, maximum = token.lexeme.split '*'

          if minimum then minimum = minimum.to_i else minimum = 0 end
          if maximum then maximum = maximum.to_i else maximum = Float::INFINITY end

          self.abnf = token.abnf
          self.range = (minimum..maximum)
        end

        def start_rule token
          compiler.push Element do |element|
            finished element
          end
        end
      end
    end
  end
end
