module ABNF
  module Parser
    class Compiler
      class RuleBuilder
        attr_reader :compiler

        def initialize compiler
          @compiler = compiler
        end

        def call token
          send token.underscore_type, token
        end

        def start_rule token
          fail
        end

        %i(
          prose_val hex_val_range hex_val_sequence dec_val_range
          dec_val_sequence bin_val_range bin_val_sequence char_val group_start
          option_start repeat_range repeat_exact rulename
        ).each do |token_type|
          define_method token_type do |token|
            start_rule token
            compiler.handle token
          end
        end
      end
    end
  end
end
