module ABNF
  module Parser
    class Compiler
      class Token
        attr_reader :abnf
        attr_reader :type

        def initialize type, abnf=nil
          @abnf = abnf
          @type = type
        end

        def == other_token
          return false unless other_token.respond_to? :abnf
          return false unless other_token.respond_to? :type

          self.abnf == other_token.abnf and self.type == other_token.type
        end

        def lexeme
          abnf
        end

        def inspect
          "(#{type} #{abnf.inspect})"
        end

        def underscore_type
          @underscore_type ||= type.downcase.gsub('-', '_')
        end
      end
    end
  end
end
