module ABNF
  module Parser
    module Rules
      class Concatenation
        attr_reader :abnf
        attr_reader :rules

        def initialize rules, abnf
          @abnf = abnf
          @rules = rules
        end

        def == other_rule
          return false unless other_rule.is_a? self.class
          self.rules == other_rule.rules
        end

        def call io, rule_list=nil
          node = Node.concatenation abnf

          match = rules.all? do |rule|
            child = rule.(io, rule_list) or break
            node << child
          end

          if match
            node
          else
            io.seek -node.octets, IO::SEEK_CUR
            nil
          end
        end
      end
    end
  end
end
