module ABNF
  module Parser
    module Rules
      class RegexpPattern
        attr_reader :abnf
        attr_reader :max_octets
        attr_reader :regexp

        def initialize regexp, abnf, max_octets
          @abnf = abnf
          @max_octets = max_octets
          @regexp = regexp
        end

        def bounded_regexp
          @bounded_regexp ||= %r{\A#{regexp}}
        end

        def call io, _=nil
          string = io.read max_octets
          return unless string
          io.seek -string.bytesize, IO::SEEK_CUR

          match_data = bounded_regexp.match string

          if match_data
            node = Node.pattern_match match_data, abnf
            io.seek node.octets, IO::SEEK_CUR
            node
          end
        end
      end
    end
  end
end
