module ABNF
  module Parser
    module Rules
      class Repetition
        attr_reader :abnf
        attr_reader :rule
        attr_reader :range

        def initialize rule, range, abnf
          @abnf = abnf
          @rule = rule
          @range = range
        end

        def == other_rule
          return false unless other_rule.is_a? self.class
          rule == other_rule.rule and range == other_rule.range
        end

        def call io, rule_list=nil
          node = Node.repetition abnf

          (0...maximum).each do
            child = rule.(io, rule_list) or break
            node << child
          end

          if node.child_count >= minimum
            node
          else
            io.seek -node.octets, IO::SEEK_CUR
            nil
          end
        end

        def maximum
          range.last
        end

        def minimum
          range.first
        end
      end
    end
  end
end
